=== debian/changelog ===
orthanc (1.5.8+dfsg-2ubuntu6) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:55:00 +0100

orthanc (1.5.8+dfsg-2ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:22:22 +0100

orthanc (1.5.8+dfsg-2ubuntu4) focal; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 19:03:12 +0000

orthanc (1.5.8+dfsg-2ubuntu3) focal; urgency=medium

  * Update cmake patch to a more backwards compatible one.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 09 Feb 2020 07:39:42 +0000

orthanc (1.5.8+dfsg-2ubuntu2) focal; urgency=medium

  * There is only V3 API now.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 12:30:48 +0000

orthanc (1.5.8+dfsg-2ubuntu1) focal; urgency=medium

  * Fix build when using new 1.71 cmake files

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 01:01:12 +0000

orthanc (1.5.8+dfsg-2build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 02 Feb 2020 20:22:23 +0100

orthanc (1.5.8+dfsg-2) unstable; urgency=medium

  * Disabling unit test "ImageProcessing.Convolution" on i386

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 17 Oct 2019 09:40:16 +0200

orthanc (1.5.8+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 16 Oct 2019 15:54:37 +0200
